package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntDeserializer;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntSerializer;
// UnionType: TransactionType
// UnionValue: AddCredits

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("AddCredits")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class AddCredits implements TransactionBody {
	public final TransactionType type = TransactionType.ADD_CREDITS;
	private Url recipient;
	private java.math.BigInteger amount;
	private long oracle;

    //
	public Url getRecipient() {
	    return recipient;
	}
	public void setRecipient(final Url value) {
	    this.recipient = value;
	}

	public AddCredits recipient(final Url value) {
	    setRecipient(value);
	    return this;
	}
	public AddCredits recipient(final String value) {
	    setRecipient(Url.toAccURL(value));
	    return this;
	}
	@JsonDeserialize(using = GoBigIntDeserializer.class)
	public java.math.BigInteger getAmount() {
	    return amount;
	}
	@JsonSerialize(using = GoBigIntSerializer.class)
	public void setAmount(final java.math.BigInteger value) {
	    this.amount = value;
	}

	public AddCredits amount(final java.math.BigInteger value) {
	    setAmount(value);
	    return this;
	}
	public long getOracle() {
	    return oracle;
	}
	public void setOracle(final long value) {
	    this.oracle = value;
	}

	public AddCredits oracle(final long value) {
	    setOracle(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.recipient == null)) {
            marshaller.writeUrl(2, this.recipient);
        }
        if (!((this.amount).equals(java.math.BigInteger.ZERO))) {
            marshaller.writeBigInt(3, this.amount);
        }
        if (!(this.oracle == 0)) {
            marshaller.writeUint(4, this.oracle);
        }
        return marshaller.array();
    }
}
